#include "basecalc.h"
#include <QPoint>
#include <QDateTime>

/*
bool operator<(QPoint a, QPoint b)
{
    if (a.x() < b.x()) return true;
    if (a.x() > b.x()) return false;

    //if (a.y() < b.y()) return true;
    //if (a.y() > b.y()) return false;

    return false;
}

bool operator<(QLine a, QLine b)
{
    if (a.x1() < b.x1()) return true;
    if (a.x1() > b.x1()) return false;

    if (a.y1() < b.y1()) return true;
    if (a.y1() > b.y1()) return false;

    if (a.x2() < b.x2()) return true;
    if (a.x2() > b.x2()) return false;

    if (a.y2() < b.y2()) return true;
    if (a.y2() > b.y2()) return false;

    return false;
}
*/
BaseCalc::BaseCalc(QObject *parent) :
    QThread(parent)
{
}

// static
QVector<int> BaseCalc::makeMatrix(int n)
{
    qsrand(QDateTime::currentMSecsSinceEpoch());
    matrix = QVector<int>(n*n);
    QVector<int> &vect = matrix;
    towns.clear();
    for (int i=0; i<n; ++i){
        QPoint point(qrand()%maxW, qrand()%maxH);
        towns << point;
        vect[i*(n+1)] = 99;
    }
    for (int i=0; i<n-1; ++i)
        for (int j=i+1; j<n; ++j){
            int a = towns[i].x() - towns[j].x();
            int b = towns[i].y() - towns[j].y();
            vect[i*n+j] = sqrt(a*a + b*b);
            vect[i+j*n] = vect[i*n+j];
        }
    return vect;
}
QString BaseCalc::printMatrix(QVector<int>& vect)
{
    int n = sqrt(vect.count());
    QString s;
    QString l;
    for (int i=0; i<n; ++i){
        for (int j=0; j<n; ++j){
            l=" "; if (vect[i*n+j]<10) l="  ";
            s += tr("%1%2").arg(vect[i*n+j]).arg(l);
        }
        s += "\n";
    }
    return s;
}

qint64 BaseCalc::fact(int i)
{
    if (i>1) return i*fact(i-1);
    else return 1;
}

void BaseCalc::calculate(QVector<int>& matr)
{
    matrix = matr;
    count = sqrt(matr.count());
    minPath = maxBenween2*count;
    iters = count*count;
    current = 0;
}

void BaseCalc::drawPath(QVector<int> been, QColor color)
{
    int n = been.count();
    if (n > count) n = count;
    for (int i=0; i<n-1; ++i){
        emit drawLine(QPoint(been[i],been[i+1]), color);
    }
}

