#include "comymin.h"
#include <QDateTime>

ComyMin::ComyMin()
{
}

void ComyMin::calculate(QVector<int>& matr)
{
    matrix = matr;
    count = sqrt(matr.count());
    minPath = maxBenween2*count;
    iters = 1;
    current = 0;
}

void ComyMin::run()
{
    qsrand(QDateTime::currentMSecsSinceEpoch());
    int minEl = maxBenween2;
    int i0, j0;
    for (int i=0; i<count; ++i)
        for (int j=0; j<count; ++j)
            if (matrix[count*i+j] < minEl) {
                minEl = matrix[count*i+j];
                i0 = i;
                j0 = j;
            }
    QVector<int> been;
    been << i0 << j0;

    QVector<int> will;
    for (int i=0; i<count; ++i)
        if (i!=i0 && i!=j0) will << i;

    recursive(been, will);

    QColor color(255,255,0,200);
    drawPath(minPathPoints, color);
    //drawLine(QPoint(been[0],been[1]), color);
}

void ComyMin::recursive(QVector<int> been, QVector<int> will)
{
    int n = will.count();
    if (n>0){
    int minEl = maxBenween2;
    int i=been.last(), j0;
    for (int j=0; j<n; ++j)
        if (matrix[count*i+will[j]] < minEl) {
            minEl = matrix[count*i + will[j] ];
            j0 = j;
        }
    QVector<int> will2;
    for (int j=0; j<n; ++j)
        if (j!=j0) will2 << will[j];
    recursive(been << will[j0], will2);
    } else {
        int m = been.count()-1;
        int sum = 0, pos;
        for (int i=0; i<m; ++i){
            pos = been[i]*count + been[i+1];
            sum += matrix[pos];
        }
        if (sum < minPath) {
            minPath = sum;
            minPathPoints = been;
        }
        current++;
    }
}

