#include "comymrand.h"
#include <QDateTime>
#include <QtAlgorithms>

ComyMrand::ComyMrand()
{
}

void ComyMrand::calculate(QVector<int>& matr)
{
    matrix = matr;
    count = sqrt(matr.count());
    minPath = maxBenween2*count;
    iters = count;
    current = 0;
}

void ComyMrand::run()
{
    qsrand(QDateTime::currentMSecsSinceEpoch());
    for (int i0 = 0; i0<count; ++i0){
        QVector<int> been;
        been << i0;

        QVector<int> will;
        for (int i=0; i<count; ++i)
            if (i!=i0) will << i;

        recursive(been, will);
    }

    QColor color(255,155,0,200);
    drawPath(minPathPoints, color);
}

void ComyMrand::recursive(QVector<int> been, QVector<int> will)
{
    int n = will.count();
    if (n>0){
    int il=been.last();
    QVector<QPoint> toSort;// x=len, y=index
    for (int j=0; j<n; ++j){
        toSort << QPoint(matrix[count*il+will[j]], j);
    }
    qSort(toSort);
    int n1 = 1;// if (n1>=2) {slow(O(n1^n)); mistakes; n <= 20}
    if (n1 > n) n1 = n;
    for (int i=0; i<n1; ++i){
        QVector<int> will2;
        QPoint& p = toSort[i];
        for (int j=0; j<n; ++j)
            if (j != p.y()) will2 << will[j];
        recursive(been << will[p.y()], will2);
    }
    } else {
        int m = been.count()-1;
        int sum = 0, pos;
        for (int i=0; i<m; ++i){
            pos = been[i]*count + been[i+1];
            sum += matrix[pos];
        }
        if (sum < minPath) {
            minPath = sum;
            minPathPoints = been;
        }
        current++;
    }
}

