#include "comyrand.h"
#include "QDateTime"

ComyRand::ComyRand()
{
}

void ComyRand::run()
{
    qsrand(QDateTime::currentMSecsSinceEpoch());
    for (int step=0; step<iters; ++step)
    {
        int i0 = qrand()%count;

        QVector<int> been;
        been << i0;

        QVector<int> will;
        for (int i=0; i<count; ++i)
            if (i!=i0) will << i;

        recursive(been, will);
    }
    drawPath(minPathPoints, QColor(250, 20, 50, 200));
}

void ComyRand::recursive(QVector<int> been, QVector<int> will)
{
    int n = will.count();
    if (n>0){
        int j0 = qrand()%n;
        been << will[j0];

        QVector<int> will2;
        for (int i=0; i<n; ++i)
            if (i!=j0) will2 << will[i];

        recursive(been, will2);
    } else {
        int m = been.count()-1;
        int sum = 0, pos;
        for (int i=0; i<m; ++i){
            pos = been[i]*count + been[i+1];
            sum += matrix[pos];
        }
        if (sum < minPath) {
            minPath = sum;
            minPathPoints = been;
        }
        current++;

        if (count > 15)
        if (current % (int)(iters/maxPst) == 0)
            emit progress(current*maxPst/iters);
    }
}

