#include "comywrand.h"
#include <QDateTime>

ComyWrand::ComyWrand()
{
}

// returns index of chosen element
int lenRand(QVector<int> willval)
{
    int n = willval.count();
    int sum = 0;
    for (int i=0; i<n; ++i)
        sum += BaseCalc::maxBenween2/(willval[i]+1);
    int rand = qrand()%sum;
    int gran=BaseCalc::maxBenween2/(willval[0]+1);
    int next = n-1;
    for (int i=0; i<n; ++i){
        if (rand<gran){
            next = i;
            break;
        }
        gran += BaseCalc::maxBenween2/(willval[i]+1);
    }
    return next;
}

void ComyWrand::run()
{
    qsrand(QDateTime::currentMSecsSinceEpoch());
    for (int step=0; step<iters; ++step)
    {
        int sum = 0;
        for (int i=0; i<count; ++i)
            for (int j=0; j<count; ++j)
                if (i!=j) sum += matrix[i*count+j];
        int r0 = qrand()%sum;
        int i0, j0;
        int gran=0;
        for (int i=0; i<count; ++i)
            for (int j=0; j<count; ++j)
                if (i!=j) {
                    gran += matrix[i*count+j];
                    if (r0 < gran){
                        i0 = i;
                        j0 = j;
                        break;
                    }
                }

        QVector<int> been;
        been << i0 << j0;

        QVector<int> will;
        for (int i=0; i<count; ++i)
            if (i!=i0 && i!=j0) will << i;

        recursive(been, will);
    }
    drawPath(minPathPoints, QColor(20, 250, 50, 200));
}

void ComyWrand::recursive(QVector<int> been, QVector<int> will)
{
    int n = will.count();
    if (n>0){
        int i0 = been.last();
        QVector<int> willVal;
        for (int i=0; i<n; ++i)
            willVal << matrix[i0*count + will[i]];
        int j0 = lenRand(willVal);
                //qrand()%n;
        been << will[j0];

        QVector<int> will2;
        for (int i=0; i<n; ++i)
            if (i!=j0) will2 << will[i];

        recursive(been, will2);
    } else {
        int m = been.count()-1;
        int sum = 0, pos;
        for (int i=0; i<m; ++i){
            pos = been[i]*count + been[i+1];
            sum += matrix[pos];
        }
        if (sum < minPath) {
            minPath = sum;
            minPathPoints = been;
        }
        current++;

        if (count > 15)
        if (current % (iters/maxPst) == 0)
            emit progress(current*maxPst/iters);
    }
}

