#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>
#include "basecalc.h"
#include "graf.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void calcBrutForse(QVector<int> matr);

public slots:
    void calculate();
    void countChanged(int co);
    void progress(int p);
    void finished();
    void brut14(bool checked);

protected:
    int mCount;
    qint64 dt;
    bool printMatrix;
    QVector<BaseCalc*> calcMethods;
    Graf* graf;
    QVector<int> matr;
    void paintEvent(QPaintEvent *event);

private:
    int step;
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
